/*******************************************************************************
 * Copyright (c) 2003, 2007 s IT Solutions AT Spardat GmbH .
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     s IT Solutions AT Spardat GmbH - initial API and implementation
 *******************************************************************************/

// @(#) $Id: ProviderResultServer.java 2089 2007-11-28 13:56:13Z s3460 $
package at.spardat.xma.datasource;


/**
 * The type of the returned value object in method {@link XMATabularDataSourceServer#provideTable}.
 *
 * @author YSD, 16.06.2003 15:36:13
 */
public class ProviderResultServer {

    /**
     * Holds the table returned by <tt>provideTable</tt>. May be <tt>null</tt> if
     * <tt>provideTable</tt> decides that the table is unchanged based on the
     * provided <tt>lastModified</tt> timestamp.
     */
    public TabularData          table_;

    /**
     * The callee of <tt>provideTable</tt> may return a <tt>lastModified</tt> timestamp
     * or not, depending on whether he knows it. A timestamp of
     * {@link ITabularDataSource#UNKNOWN_TIMESTAMP} is defined
     * to be the undefined timestamp.
     */
    public long                 lastModified_ = ITabularDataSource.UNKNOWN_TIMESTAMP;

}
