/*******************************************************************************
 * Copyright (c) 2003, 2007 s IT Solutions AT Spardat GmbH .
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     s IT Solutions AT Spardat GmbH - initial API and implementation
 *******************************************************************************/

//@(#) $Id: XmaSerializable.java 2089 2007-11-28 13:56:13Z s3460 $
package at.spardat.xma.serializer;

import java.io.IOException;

/**
 * Objects implementing this interface may be directy read and written
 * from and to XmaOutput/XmaInput without relying on the standard
 * java serialization mechanism. <p>
 * 
 * Classes implementing this interface must have a public default
 * constructor. It will be called before calling deserialize to create
 * an instance.
 * 
 * @author YSD, 12.02.2005  
 */
public interface XmaSerializable {
    
    /**
     * Maps the information in this to <tt>out</tt>.
     */
    public abstract void serialize (XmaOutput out) throws IOException;
    
    /**
     * Reads the information from <tt>in</tt> and sets instance variable's
     * values in this.
     */
    public abstract void deserialize (XmaInput in) throws IOException, ClassNotFoundException;
}
